package dao.imp;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import dao.dao;
import entity.dep;
import entity.emp;
import util.DButil;

public class dao_imp implements dao{

	//查找所有职员信息实现类
	public List<emp> find_all_emp() {
		// TODO Auto-generated method stub
		String sql = "select * from Emp";
		System.out.println("-------------------");
		List<emp> list = DButil.que(sql);
		return list;
	}

	//查找特定编号的职员信息
	public emp find_emp(int id) {
		// TODO Auto-generated method stub
		emp emp1 = null;
		String sql = "select * from Emp where Empno = ?";
		List<emp> list =DButil.que(sql,id);
		if(list.isEmpty()==true) {
			return null;
		}
		return list.get(0);
	}
	
	//插入一个职员信息
	public int save_emp(emp e) {
		String sql = "insert into Emp value(?,?,?,?,?,?,?,?)";
		Object[] obj = {
				e.getId(),
				e.getName(),
				e.getJob(),
				e.getMgr(),
				e.getEnterdate(),
				e.getSal(),
				e.getComm(),
				e.getDeptno()
		};
		return DButil.excuteupdate(sql, obj);
	}

	
	//删除特定编号的职员信息
	public int delete_emp(int empno) {
		String sql  = "delete from Emp where Empno = ?";
		return DButil.excuteupdate(sql, empno);
	}

	@Override
	public List<emp> find_emp_dpt() {
		List<emp> list = new ArrayList<emp>();
		Connection Con = null;
		Statement sta = null;
		ResultSet rs = null;
		try {
			Con = DButil.getConnection();
			sta = Con.createStatement();
			String sql = "SELECT * FROM emp e,dep d where e.deptno = d.deptno";
			rs = sta.executeQuery(sql);
			while(rs.next()) {
				int i= 1;
				int empno = rs.getInt(i++);
				String name = rs.getString(i++);
				String job = rs.getString(i++);
				int mgr = rs.getInt(i++);
				int enterdate = rs.getInt(i++);
				double sal  = rs.getDouble(i++);
				double comm = rs.getDouble(i++);
				int deptno = rs.getInt(i++);
				String dname = rs.getString("dname");
				int num = rs.getInt("dnum");
				
				emp emp1 = new emp(empno, name, job, mgr, enterdate, sal, comm, deptno);
				dep d = new dep(deptno,dname,num);
				emp1.setDep(d);
				list.add(emp1);
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}finally {
			DButil.closeall(sta, Con, rs);
		}
		return list;
	}
}
