package util;

import java.io.IOException;
import java.io.InputStream;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.Properties;

import org.apache.log4j.Logger;

import entity.emp;

public class DButil {
	private static Logger logger = Logger.getLogger(DButil.class);
	static String driver=null;
	static String url=null;
	static String user=null;
	static String pwd=null;
	
	static {
		
		InputStream is = DButil.class.getResourceAsStream("/conn.properties");
		Properties ps = new Properties();
		try {
			ps.load(is);
			driver = ps.getProperty("Driver");
			url=   ps.getProperty("url");
			user = ps.getProperty("user");
			pwd  = ps.getProperty("pwd");
			logger.info("驱动已经加载"+driver+"url"+url);
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}	
	}
	
	public static Connection getConnection(){
		Connection Con = null;
		try {
			Class.forName(driver);
			Con = DriverManager.getConnection(url, user, pwd);
			logger.info("数据库连接成功！！！！");
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
		return Con;
	}
	
	
	public static void closeall(Statement sta,Connection Con,ResultSet rs) {
		try {
			sta.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			Con.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
	public static int excuteupdate(String sql,Object...obj) {
		Connection Con = null;
		PreparedStatement Sta = null;
		int n = 0;
		try {
			Con = DButil.getConnection();
			Sta = Con.prepareStatement(sql);
			for(int i =0;i<obj.length;i++) {
				Sta.setObject(i+1,obj[i]);
			}
			n = Sta.executeUpdate();
		} catch (SQLException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}finally {
			DButil.closeall(Sta, Con, null);
		}
		return n;
	}
	
	
	public static List<emp> que(String sql,Object...obj){
		List<emp> list = new ArrayList<emp>();
		Connection Con = null;
		PreparedStatement ps = null;
		ResultSet rs = null;
		int j=1;
		try {
			Con = DButil.getConnection();
			ps = Con.prepareStatement(sql);
			
			for(Object ob:obj) {
				ps.setObject(j++,ob);
			}
			rs = ps.executeQuery();
			while(rs.next()) {
				int i= 1;
				emp e = new emp();
				int empno = rs.getInt(i++);
				e.setId(empno);
				String name = rs.getString(i++);
				e.setName(name);
				String job = rs.getString(i++);
				e.setJob(job);
				int mgr = rs.getInt(i++);
				e.setMgr(mgr);
				int enterdate = rs.getInt(i++);
				e.setEnterdate(enterdate);
				double sal  = rs.getDouble(i++);
				e.setSal(sal);
				double comm = rs.getDouble(i++);
				e.setComm(comm);
				int deptno = rs.getInt(i++);
				e.setDeptno(deptno);
				list.add(e);
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}finally {
			DButil.closeall(ps, Con, rs);
		}
		return list;
	}
	
}
